<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class RegQuizController extends JController
{
	function display()
	{
		global $mainframe;
		
		// load component parameters
		$params = &$mainframe->getParams();
		
		// Set a default view if none exists
		if ( ! JRequest::getCmd( 'view' ) ) {
			JRequest::setVar('view', 'quiz' );
		}
		
		parent::display();
	}
	
	function score()
	{
		global $mainframe;
		
		$params = &$mainframe->getParams();
		$num_questions = $params->get('num_questions');
		
		$view =& $this->getView('quiz', 'html');
			
		$model =& $this->getModel('quiz');
		$model->scoreQuiz();
		
		$score = (string) $model->getScore();
		
		// Do we show the user their score?
		$msg = '';
		if($params->get('show_score') != '') {
			$msg .= 'Score: ' . $score . '/' . $num_questions . '<br />';
		}
			
		// Test the answers to see if the user passed or failed
		if($model->isPassed()) {
			$this->upgradePermissions();

			if($params->get('msg_pass') != '') {
				$msg .= $params->get('msg_pass');
			}
			
			if($params->get('redirect_url') != '') {
				$redirect_url = $params->get('redirect_url');
			} else {
				$redirect_url = 'index.php';
			}
			
			$this->setRedirect($redirect_url,$msg);	
		} else {
			if($params->get('msg_fail') != '') {
				$msg .= $params->get('msg_fail');
			}
			
			$this->setRedirect('index.php?option=com_regquiz',$msg);
		}
		
		$view->setModel($model, true);
				
		$view->display();
	}
	
	function upgradePermissions()
	{
		global $mainframe;
		
		$params = &$mainframe->getParams();
		$user =& JFactory::getUser();
		
		$promotion_group = $params->get('promotion');
		
		// only change the group if the user is currently
		// at a lower access level
		if($user->get('gid') < $promotion_group) {
			$user->set('gid',$promotion_group);
			$user->save();
		}
		
	}
}
