<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class RegQuizModelQuiz extends JModel
{

	/**
	 * Quiz score
	 *
	 * @var int
	 */
	var $_score = null;
	
	/**
	 * Questions data array
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * Constructor
	 *
	 * @since 1.5
	 */
	function __construct() {
		parent::__construct();
	}
	
	function _setScore($score) {
		$this->_score = $score;
	}
	
	function getScore() {
		return $this->_score;
	}

	/**
	 * Method to get quesiton item data for the quiz
	 *
	 * @access public
	 * @return array
	 */
	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		
		// decode answers into php array
		foreach($this->_data as &$item) {
			$item->answers = json_decode($item->answers);
		}

		return $this->_data;
	}

	function _buildQuery() {
		global $mainframe;
		
		$params 	= &$mainframe->getParams();
		$limit 		= $params->get('num_questions');
		$ordering 	= $params->get('display_order');
		
		switch($ordering) {
			case 'ordering':
				$orderby = 'ordering ASC';
				break;
			case 'random':
			default:
				$orderby = 'RAND()';
				break;
		}
		
		if (empty($this->_category)) {
			$query = 'SELECT * ' .
				' FROM #__regquiz_questions' .
				' WHERE published = 1' .
				' ORDER BY ' . $orderby;
			if($limit > 0) {
				$query .= ' LIMIT ' . $limit; 
			}
		}
		
		return $query;
	}
	
	function isPassed() {
		global $mainframe;
		
		$params = $mainframe->getParams();

		$min_score = $params->get('min_score');
		
		if ($this->getScore() >= $min_score) {
			return true;
		} else {
			return false;
		}
		
	}
	
	function scoreQuiz() {
		global $mainframe;
		
		$post = JRequest::get('post');

		$answers = array();
		// loop through post and pull out all quiz answers
		foreach($post as $key=>$val) {
			// question vars are name like q2, q31, etc. according to their database id
			if(preg_match("/q[0-9]+/",$key)) {
				$answers[substr($key,1,strlen($key))] = $val;
			}
		}
		
		$params = $mainframe->getParams();
		// set initial score to 100%
		$score = $count = $params->get('num_questions');
		$min_score = $params->get('min_score');
		
		// deduct any blank answers from score
		$score -= ($count - count($answers));
		
		// check each answer, deducting a point for each incorrect answer
		// we only care about pass/fail, so we can end the check once the score
		// falls below the minimum pass score
		while($score >= $min_score && $count > 0) {
			foreach($answers as $id=>$val) {
				if(false === $this->checkAnswer($id,$val)) {
					$score--;
				}
				$count--;
			}
		}
		
		$this->_setScore($score);
	}
	
	function checkAnswer($id,$val) {
		$query = 'SELECT * ' .
					' FROM #__regquiz_questions' .
					' WHERE id = ' . $id .
					' AND correct = ' . $val;
		$this->_db->setQuery($query);
		if($this->_db->loadResult()) {
			return true;
		} else {
			return false;
		}
					
	}
}
